<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__bsp__network__buffer" kind="group">
    <compoundname>group_bsp_network_buffer</compoundname>
    <title>Buffer management</title>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1gacdcb08de31442a9e5d1f32b4e99a2de3" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>whd_result_t</type>
        <definition>whd_result_t cy_host_buffer_get</definition>
        <argsstring>(whd_buffer_t *buffer, whd_buffer_dir_t direction, unsigned short size, unsigned long timeout_ms)</argsstring>
        <name>cy_host_buffer_get</name>
        <param>
          <type>whd_buffer_t *</type>
          <declname>buffer</declname>
        </param>
        <param>
          <type>whd_buffer_dir_t</type>
          <declname>direction</declname>
        </param>
        <param>
          <type>unsigned short</type>
          <declname>size</declname>
        </param>
        <param>
          <type>unsigned long</type>
          <declname>timeout_ms</declname>
        </param>
        <briefdescription>
<para>Allocates a packet buffer. </para>        </briefdescription>
        <detaileddescription>
<para>Attempts to allocate a packet buffer of the size requested. It can do this by allocating a pre-existing packet from a pool, using a static buffer, or by dynamically allocating memory. The method of allocation does not concern WHD, however it must match the way the network stack expects packet buffers to be allocated. Usually WHD requires packet of size of WHD_LINK_MTU which includes the MTU. Refer to whd_types.h to find the size of WHD_LINK_MTU.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: A pointer which receives the allocated packet buffer handle </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>direction</parametername>
</parameternamelist>
<parameterdescription>
<para>: Indicates transmit/receive direction that the packet buffer is used for. This may be needed if tx/rx pools are separate. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>size</parametername>
</parameternamelist>
<parameterdescription>
<para>: The number of bytes to allocate. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>timeout_ms</parametername>
</parameternamelist>
<parameterdescription>
<para>Time to wait for a packet buffer to be available</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>: CY_RSLT_SUCCESS or WHD_BUFFER_ALLOC_FAIL if the buffer could not be allocated </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="61" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="34" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.h" line="62" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1gaac05ad889f09b6e8ef43503ba475a21f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cy_buffer_release</definition>
        <argsstring>(whd_buffer_t buffer, whd_buffer_dir_t direction)</argsstring>
        <name>cy_buffer_release</name>
        <param>
          <type>whd_buffer_t</type>
          <declname>buffer</declname>
        </param>
        <param>
          <type>whd_buffer_dir_t</type>
          <declname>direction</declname>
        </param>
        <briefdescription>
<para>Releases a packet buffer. </para>        </briefdescription>
        <detaileddescription>
<para>This function is used by WHD to indicate that it no longer requires a packet buffer. The buffer can then be released back into a pool for reuse, or the dynamically allocated memory can be freed, according to how the packet was allocated. Returns void since WHD cannot do anything about failures</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: The handle of the packet buffer to be released </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>direction</parametername>
</parameternamelist>
<parameterdescription>
<para>: Indicates transmit/receive direction that the packet buffer has been used for. This might be needed if tx/rx pools are separate. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="67" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="63" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.h" line="76" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1ga782b3a560466f80c438e5c306107eeb1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint8_t *</type>
        <definition>uint8_t* cy_buffer_get_current_piece_data_pointer</definition>
        <argsstring>(whd_buffer_t buffer)</argsstring>
        <name>cy_buffer_get_current_piece_data_pointer</name>
        <param>
          <type>whd_buffer_t</type>
          <declname>buffer</declname>
        </param>
        <briefdescription>
<para>Retrieves the current pointer of a packet buffer. </para>        </briefdescription>
        <detaileddescription>
<para>Since packet buffers usually need to be created with space at the front for additional headers, this function allows WHD to get the current 'front' location pointer.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: The handle of the packet buffer whose pointer is to be retrieved</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>: The packet buffer's current pointer. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="74" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="69" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.h" line="88" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1ga9890010d1a7246a440477d47dc2c7b2b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint16_t</type>
        <definition>uint16_t cy_buffer_get_current_piece_size</definition>
        <argsstring>(whd_buffer_t buffer)</argsstring>
        <name>cy_buffer_get_current_piece_size</name>
        <param>
          <type>whd_buffer_t</type>
          <declname>buffer</declname>
        </param>
        <briefdescription>
<para>Retrieves the size of a packet buffer. </para>        </briefdescription>
        <detaileddescription>
<para>Since packet buffers usually need to be created with space at the front for additional headers, the memory block used to contain a packet buffer will often be larger than the current size of the packet buffer data. This function allows WHD to retrieve the current size of a packet buffer's data.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: The handle of the packet buffer whose size is to be retrieved</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>: The size of the packet buffer. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="81" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="76" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.h" line="101" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1gafd58907304a573df160ea12c97199c2e" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>whd_result_t</type>
        <definition>whd_result_t cy_buffer_set_size</definition>
        <argsstring>(whd_buffer_t buffer, unsigned short size)</argsstring>
        <name>cy_buffer_set_size</name>
        <param>
          <type>whd_buffer_t</type>
          <declname>buffer</declname>
        </param>
        <param>
          <type>unsigned short</type>
          <declname>size</declname>
        </param>
        <briefdescription>
<para>Sets the current size of a WHD packet. </para>        </briefdescription>
        <detaileddescription>
<para>This function sets the current length of a WHD packet buffer</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: The packet to be modified </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>size</parametername>
</parameternamelist>
<parameterdescription>
<para>: The new size of the packet buffer</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>: CY_RSLT_SUCCESS or WHD_PMK_WRONG_LENGTH if the requested size is not valid </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="97" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="83" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.h" line="112" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1gaa284f33e6c96712370302d61d4b7cd58" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>whd_result_t</type>
        <definition>whd_result_t cy_buffer_add_remove_at_front</definition>
        <argsstring>(whd_buffer_t *buffer, int32_t add_remove_amount)</argsstring>
        <name>cy_buffer_add_remove_at_front</name>
        <param>
          <type>whd_buffer_t *</type>
          <declname>buffer</declname>
        </param>
        <param>
          <type>int32_t</type>
          <declname>add_remove_amount</declname>
        </param>
        <briefdescription>
<para>Moves the current pointer of a packet buffer. </para>        </briefdescription>
        <detaileddescription>
<para>Since packet buffers usually need to be created with space at the front for additional headers, this function allows WHD to move the current 'front' location pointer so that it has space to add headers to transmit packets, and so that the network stack does not see the internal WHD headers on received packets.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: A pointer to the handle of the current packet buffer for which the current pointer will be moved. On return this may contain a pointer to a newly allocated packet buffer which has been daisy chained to the front of the given one. This would be the case if the given packet buffer didn't have enough space at the front. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>add_remove_amount</parametername>
</parameternamelist>
<parameterdescription>
<para>: This is the number of bytes to move the current pointer of the packet buffer - a negative value increases the space for headers at the front of the packet, a positive value decreases the space.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>: CY_RSLT_SUCCESS or WHD_PMK_WRONG_LENGTH if the added amount is outside the size of the buffer </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="110" bodyfile="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.c" bodystart="99" column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.h" line="133" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__bsp__network__buffer_1ga3299898b9eba8861438225b85f36f528" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cy_network_process_ethernet_data</definition>
        <argsstring>(whd_interface_t interface, whd_buffer_t buffer)</argsstring>
        <name>cy_network_process_ethernet_data</name>
        <param>
          <type>whd_interface_t</type>
          <declname>interface</declname>
        </param>
        <param>
          <type>whd_buffer_t</type>
          <declname>buffer</declname>
        </param>
        <briefdescription>
<para>Called by WHD to pass received data to the network stack. </para>        </briefdescription>
        <detaileddescription>
<para>Packets received from the Wi-Fi network by WHD are forwarded to by calling function ptr which must be implemented in the network interface. Ethernet headers are present at the start of these packet buffers.</para><para>This function is called asynchronously in the context of the WHD thread whenever new data has arrived. Packet buffers are allocated within WHD, and ownership is transferred to the network stack. The network stack or application is thus responsible for releasing the packet buffers. Most packet buffering systems have a pointer to the 'current point' within the packet buffer. When this function is called, the pointer points to the start of the Ethernet header. There is other inconsequential data before the Ethernet header.</para><para>It is preferable that the (whd_network_process_ethernet_data)() function simply puts the received packet on a queue for processing by another thread. This avoids the WHD thread being unnecessarily tied up which would delay other packets being transmitted or received.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>interface</parametername>
</parameternamelist>
<parameterdescription>
<para>: The interface on which the packet was received. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>buffer</parametername>
</parameternamelist>
<parameterdescription>
<para>: Handle of the packet which has just been received. Responsibility for releasing this buffer is transferred from WHD at this point. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_WHD_GLUE/whd-bsp-integration/cy_network_buffer.h" line="162" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Basic set of APIs for dealing with network packet buffers. </para>    </briefdescription>
    <detaileddescription>
    </detaileddescription>
  </compounddef>
</doxygen>